"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var src_exports = {};
__export(src_exports, {
  applyBuilderSwcConfig: () => applyBuilderSwcConfig,
  default: () => src_default,
  factory: () => factory,
  swcPlugin: () => swcPlugin
});
module.exports = __toCommonJS(src_exports);
var import_utils = require("@modern-js/utils");
var import_plugin_swc = require("@rsbuild/plugin-swc");
var import_logger = require("@modern-js/utils/logger");
function factory(name, modifySwcOptions) {
  return () => ({
    name,
    setup: (api) => ({
      prepare() {
        const context = api.useAppContext();
        if (!context.builder || context.bundlerType === "rspack") {
          return;
        }
        const config = api.useResolvedConfigContext();
        const { esbuild, swc = {} } = config.tools;
        const swcOptions = modifySwcOptions(swc);
        const finalConfig = applyBuilderSwcConfig(swcOptions, esbuild, (0, import_utils.isSSR)(config));
        var _config_performance_transformLodash;
        context.builder.addPlugins([
          (0, import_plugin_swc.pluginSwc)({
            ...finalConfig,
            transformLodash: (_config_performance_transformLodash = config.performance.transformLodash) !== null && _config_performance_transformLodash !== void 0 ? _config_performance_transformLodash : true
          })
        ]);
      }
    })
  });
}
function applyBuilderSwcConfig(swc, esbuild, isSSR2) {
  if (isSSR2) {
    swc = applyConfig(swc, (config) => {
      var _config;
      var _extensions;
      (_extensions = (_config = config).extensions) !== null && _extensions !== void 0 ? _extensions : _config.extensions = {};
      config.extensions.loadableComponents = true;
    });
  }
  return applyConfig(swc, (config) => {
    if (esbuild) {
      if (config.jsMinify !== false && esbuild.minimize !== false) {
        import_logger.logger.warn("You have enabled both esbuild minimizer and SWC minimizer, which will cause conflicts. Please remove `tools.esbuild` config and only use SWC to minimize your code.");
      }
      if (esbuild.loader !== false) {
        import_logger.logger.warn("You have enabled both esbuild loader and SWC loader, which will cause conflicts. Please remove `tools.esbuild` config and only use SWC to transform your code.");
      }
    }
  });
}
const PLUGIN_NAME = "@modern-js/plugin-swc";
const swcPlugin = factory(PLUGIN_NAME, (swcOptions) => {
  return applyConfig(swcOptions, (swcOptions2) => {
    var _swcOptions;
    var _extensions;
    (_extensions = (_swcOptions = swcOptions2).extensions) !== null && _extensions !== void 0 ? _extensions : _swcOptions.extensions = {};
    swcOptions2.extensions.ssrLoaderId = {
      runtimePackageName: "@modern-js/runtime",
      functionUseLoaderName: "useLoader"
    };
  });
});
function applyConfig(rawConfig, handler) {
  if (typeof rawConfig === "function") {
    return (config, utils) => {
      handler(config);
      return rawConfig(config, utils) || config;
    };
  } else {
    handler(rawConfig);
    return rawConfig;
  }
}
var src_default = swcPlugin;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  applyBuilderSwcConfig,
  factory,
  swcPlugin
});
